unit TCP_Server;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ScktComp, StdCtrls, ComCtrls;

type
  TTCPServer = class(TForm)
    btListen: TButton;
    edLocalPort: TEdit;
    edSendData: TEdit;
    btSend: TButton;
    mbReceiveData: TMemo;
    btDisconnect: TButton;
    StatusBar1: TStatusBar;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ServerSocket1: TServerSocket;
    cbCRLF: TCheckBox;
    procedure btListenClick(Sender: TObject);
    procedure btSendClick(Sender: TObject);
    procedure btDisconnectClick(Sender: TObject);
    procedure OnListen(Sender: TObject; Socket: TCustomWinSocket);
    procedure OnAccept(Sender: TObject; Socket: TCustomWinSocket);
    procedure OnClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure OnClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure OnClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ServerSocket1ClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  TCPServer: TTCPServer;

implementation

{$R *.DFM}

//start server listening by button click
procedure TTCPServer.btListenClick(Sender: TObject);
begin
  If edLocalPort.Text <> '' Then
  begin
    ServerSocket1.Port := strtoint(edLocalPort.Text);
    ServerSocket1.Open;
  end
  Else ShowMessage ('No local port!');
end;

//event handling and display connection state
procedure TTCPServer.OnListen(Sender: TObject; Socket: TCustomWinSocket);
begin
  Statusbar1.SimpleText := 'Listening';
  btSend.Enabled := False;
  btDisconnect.Enabled := False;
  btListen.Enabled := False;
end;

procedure TTCPServer.OnAccept(Sender: TObject; Socket: TCustomWinSocket);
begin
  Statusbar1.SimpleText := 'Connected to ' + Socket.RemoteAddress;
  btSend.Enabled := True;
  btDisconnect.Enabled := True;
end;

procedure TTCPServer.OnClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Statusbar1.SimpleText := 'Listening';
  ServerSocket1.Open;
  btSend.Enabled := False;
  btDisconnect.Enabled := False;
end;

//error handling
procedure TTCPServer.OnClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  ShowMessage ('Connection Error');
  ErrorCode := 0;
  ServerSocket1.Close;
  btSend.Enabled := False;
  btDisconnect.Enabled := False;
  btListen.Enabled := True;
  Statusbar1.SimpleText := 'No Connection';
end;

//send test string on button click
procedure TTCPServer.btSendClick(Sender: TObject);
begin
  if cbCRLF.checked then
    ServerSocket1.Socket.Connections[0].SendText(edSendData.Text + #13#10)
  else
    ServerSocket1.Socket.Connections[0].SendText(edSendData.Text);
end;

//receive data handling
procedure TTCPServer.OnClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  mbReceiveData.Text := mbReceiveData.Text + Socket.ReceiveText;
end;
//end connection from server side by button click
procedure TTCPServer.btDisconnectClick(Sender: TObject);
begin
  ServerSocket1.Close;
  btListen.Enabled := True;
  btSend.Enabled := False;
  btDisconnect.Enabled := False;
  Statusbar1.SimpleText := 'No Connection';
end;

procedure TTCPServer.ServerSocket1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  if ServerSocket1.Socket.ActiveConnections > 1 then Socket.Close;
end;

end.
